package space.kklochko.jpa_hospital_example.db.repositories;

import jakarta.persistence.EntityManager;
import jakarta.persistence.TypedQuery;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalInsert;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalRemove;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalUpdate;
import space.kklochko.jpa_hospital_example.models.Department;

import java.util.ArrayList;
import java.util.UUID;

public class DepartmentRepository extends AbstractRepository<Department> {
    public DepartmentRepository(EntityManager manager){
        super(manager);
    }

    public boolean create(Department object) {
        TransactionalInsert insert = new TransactionalInsert();

        return insert.run(manager, object);
    }

    public Department read(UUID id) {
        return manager.find(Department.class, id);
    }

    public ArrayList<Department> readAll() {
        TypedQuery<Department> query = manager.createQuery("SELECT d FROM Department d", Department.class);

        return (ArrayList<Department>) query.getResultList();
    }

    public boolean update(Department object) {
        TransactionalUpdate update = new TransactionalUpdate();

        return update.run(manager, object);
    }

    public boolean delete(UUID id) {
        Department object = read(id);

        TransactionalRemove remove = new TransactionalRemove();

        return remove.run(manager, object);
    }
}
