package space.kklochko.jpa_hospital_example.models;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;

import java.sql.Timestamp;
import java.util.UUID;

@Table(name="indicators")
@Entity
@AllArgsConstructor
@Data
public class Indicator {
    @Id
    @Column(nullable = true)
    UUID id;
    String type;
    String values;
    Timestamp timestamp;

    public Indicator(){
        setId(UUID.randomUUID());
        setType("");
        setValues("");
        setTimestamp(null);
    }

    public Indicator(String type, String values, Timestamp timestamp){
        setId(UUID.randomUUID());
        setType(type);
        setValues(values);
        setTimestamp(timestamp);
    }
}

